# Charger Driver PMIC8921

## Abandoned flto's port

This repo has a WIP commit adding basic support to charger driver on Linux 4.19

[flto's GitHub commit](https://github.com/flto/linux/commit/f820a8592ec8ece6559eb38e7d5f9a5149566fe3)

Real commit author seems: `jonathan@marek.ca`

## Downstream kernel

### Makefile

Defined in: `drivers/power/Makefile` line 56

```
obj-$(CONFIG_PM8XXX_CCADC)	+= pm8xxx-ccadc.o
obj-$(CONFIG_PM8921_BMS)	+= pm8921-bms.o
ifeq ($(CONFIG_PM8921_SEC_CHARGER),y)
ifeq ($(CONFIG_SEC_PRODUCT_8930),y)
obj-$(CONFIG_PM8921_SEC_CHARGER)	+= pm8921-sec-charger-8930.o
else
obj-$(CONFIG_PM8921_SEC_CHARGER)	+= pm8921-sec-charger.o
endif
else
obj-$(CONFIG_PM8921_CHARGER)	+= pm8921-charger.o
endif 
```


### Config

#### Power

Defined in: `drivers/power/Kconfig`

Line 392

```
config PM8921_CHARGER
	tristate "PM8921 Charger driver"
	depends on MFD_PM8921_CORE
	help
	  Say Y here to enable support for pm8921 chip charger subdevice

config PM8XXX_CCADC
	tristate "PM8XXX battery current adc driver"
	depends on MFD_PM8921_CORE
	help
	  Say Y here to enable support for pm8921 chip bms subdevice
```

Line 411

```
config PM8921_BMS
	select PM8XXX_CCADC
	tristate "PM8921 Battery Monitoring System driver"
	depends on MFD_PM8921_CORE
	help
	  Say Y here to enable support for pm8921 chip bms subdevice
```

Line 426

```
config PM8921_SEC_CHARGER
	bool "samsung charger driver"
	default n
	help
	 Say Y here to enable support for samsung charging driver.
	 PM8921-charger driver is default.
	 But Samsung need modification to adjust verification spec.
	 So Samsung charging dirver is seperated.
```

Line 455

```
config SAMSUNG_LPM_MODE
	bool "Off charging mode support in sec battery driver"
	default n
	help
	 Say Y to include support for sec off charging support
```


#### Battery

Defined in `drivers/battery/Kconfig`

Line 217

```
config SAMSUNG_LPM_MODE
	bool "Off charging mode support in sec battery driver"
	default n
	help
	  Say Y to include support for sec off charging support
	  This value defined at bootloader.
	  Before enable this feature,
	  implemet power off charging in the bootloader.
```

TODO: why is it defined twice??? (Also in `.../power/KConfig`)

#### Usage

These configs do not seem to have hierarchical dependency.
So they are not enabled by default with say `CONFIG_MACH_SERRANO`.
They must be enabled manually.
In `config-samsung-serranolte.armv7` (`linux-samsung-serranolte`) file we have infact:

```
#
# MSM Board Selection
#
CONFIG_MACH_SERRANO=y
CONFIG_MACH_SERRANO_EUR_LTE=y

#
# LGE Specific Patches
#
CONFIG_SEC_PRODUCT_8930=y

#
# MODULbus GPIO expanders:
#
CONFIG_GPIO_PM8XXX=y
CONFIG_GPIO_PM8XXX_MPP=y

CONFIG_POWER_SUPPLY=y

CONFIG_PM8921_CHARGER=y
CONFIG_PM8XXX_CCADC=y
CONFIG_SAMSUNG_LPM_MODE=y

CONFIG_PM8921_BMS=y

CONFIG_PM8921_SEC_CHARGER=y

#
# Native drivers
#
CONFIG_SENSORS_PM8XXX_ADC=y
CONFIG_THERMAL_PM8XXX=y

#
# Multifunction device drivers
#
CONFIG_MFD_CORE=y

CONFIG_MFD_PM8XXX=y
CONFIG_MFD_PM8921_CORE=y

CONFIG_MFD_PM8XXX_IRQ=y

CONFIG_MFD_PM8XXX_PWM=y
CONFIG_MFD_PM8XXX_MISC=y
CONFIG_MFD_PM8XXX_SPK=y
CONFIG_MFD_PM8XXX_BATT_ALARM=y

CONFIG_REGULATOR=y
CONFIG_REGULATOR_PM8XXX=y

#
# on-CPU RTC drivers
#
CONFIG_RTC_DRV_PM8XXX=y
```


### PM8921_BMS

Defined in: `arch/arm/mach-msm/Makefile`

Line 284

```
ifdef CONFIG_MACH_SERRANO
obj-$(CONFIG_CHARGER_MAX77XXX) += board-serrano-battery.o
obj-$(CONFIG_PM8921_BMS) += bms-batterydata-serrano.o
endif
```

Line 301

```
obj-$(CONFIG_PM8921_BMS) += bms-batterydata.o bms-batterydata-desay.o batterydata-lib.o
```