# Example of borad file ported to DTS file

New DTS file in kernel v4.12-rc1: https://elixir.bootlin.com/linux/v4.12-rc1/source/arch/arm/boot/dts/gemini-nas4220b.dts

Old board file in kernel v4.11.12: https://elixir.bootlin.com/linux/v4.11.12/source/arch/arm/mach-gemini/board-nas4220b.c

## GitHub shortcut to browse old kernels

GitHub Linux repository: https://github.com/torvalds/linux/releases/tag/v4.11

## DTS creation

DTS introduced in commit: https://github.com/torvalds/linux/commit/fe7bf9dcfff5b47d138476f2cb4ed8cdc716dfd4

Second commit: https://github.com/torvalds/linux/commit/0d7a2c35d11e974b98a6396cd24b39b0f3f5bb7b

Third commit: https://github.com/torvalds/linux/commit/f328c2eac5d729a3654d2cef469b9e4acc338c4e

Commit supporting DT: https://github.com/torvalds/linux/commit/41d9830cd09f652936be95431cecfbac39ed09f7#diff-1560d3975935bd2fc0ca03e87d57bb016862fec3117457d136ffff8e5efcb9e9

## Board removal

Last edit commit: https://github.com/torvalds/linux/commit/844338e5a46f5d80566fa853c6168a78cdadab01

Delete board commit: https://github.com/torvalds/linux/commit/ee149d66d76057e40fe1354c08572f8611cf50e4

Interesting "convert to ARMv4 Multiplatform": https://github.com/torvalds/linux/commit/6dbb708a8fb8eef552d8de2b7574d92741b3bb31

## Commit order


1. [844338e](https://github.com/torvalds/linux/commit/844338e5a46f5d80566fa853c6168a78cdadab01) ARM: gemini: remove unnecessary mdio-gpio includes
	1. Last commit which edits board files???
2. [41d9830](https://github.com/torvalds/linux/commit/41d9830cd09f652936be95431cecfbac39ed09f7) ARM: gemini: DT for the Cortina Gemini SoC platforms
	1. Adds `arch/arm/mach-gemini/board-dt.c`  
	2. Board files are still there
	3. No DTS file yet
3. [6dbb708](https://github.com/torvalds/linux/commit/6dbb708a8fb8eef552d8de2b7574d92741b3bb31) ARM: gemini: convert to ARMv4 multiplatform
4. [fe7bf9d](https://github.com/torvalds/linux/commit/fe7bf9dcfff5b47d138476f2cb4ed8cdc716dfd4) ARM: dts: add a devicetree for Raidsonic NAS IB-4220-B
	1. Adds `arch/arm/boot/dts/gemini-nas4220b.dts`
	2. Seems a different branch



# Example 2: MSM8960

**TODO:** make sure commits are in chronological order (not by commit date as they might be on different branches, instead order by parent-child)

**TODO:** maybe a table structure is better here?

1. [c446407](https://github.com/gfgit/msm8930-mainline/commit/c446407c09ce0b339a84931f3d45f3dabb9f0b17) **ARM: msm: Add DT support for 8960**
	1. Initial MSM8960 support
	2. New file: `arch/arm/boot/dts/msm8960-cdp.dts`
	3. **New generic board:** `arch/arm/mach-msm/board-dt-8960.c`
2. [eebdb0c](https://github.com/gfgit/msm8930-mainline/commit/eebdb0c1e1d63532399f7cbb65ade5969d63df06) **ARM: msm: Rework timer binding to be more general**
3. [97f00f7](https://github.com/gfgit/msm8930-mainline/commit/97f00f7120fe3396302693cdc4b1d11bbacad963) **SSBI: Convert SSBI to device tree**
	1. Example on how to modify driver to bind devicetree at runtime time
4. [43f6844](https://github.com/gfgit/msm8930-mainline/commit/43f68444bce70e360ff6ce3653a54e511625f651) **gpio: msm: Add device tree and irqdomain support for gpio-msm-v2**
	1. Other example of driver modification for device tree bindig
5. [56e2d8a](https://github.com/gfgit/msm8930-mainline/commit/56e2d8a68803be438211130f58ff02c277a2daaf) **ARM: msm: Add devicetree support for msm8660-surf**
	1. Initiam MSM8660 support
	2. New file: `arch/arm/boot/dts/msm8660-surf.dts`
	3. **Edited board file:** `arch/arm/mach-msm/board-msm8x60.c`
6. [6bb27d7](https://github.com/gfgit/msm8930-mainline/commit/6bb27d7349db51b50c40534710fe164ca0d58902) **ARM: delete struct sys_timer**
	1. Interesting commit to analyze code moved from `arch/arm/mach-msm/` to `drivers/` folder because now it's generic and gets loaded based on device tree instead of being hard-coded.
	2. TODO: fetch following related commits
7. [0529e31](https://github.com/gfgit/msm8930-mainline/commit/0529e315bbda5d502c93df2cfafba9bb337fbdf4) **ARM: use common irqchip_init for GIC init**
	1. Example of function removal from board files. Now calls generic functions
8. [5b67bfb](https://github.com/gfgit/msm8930-mainline/commit/5b67bfbae6612c4caa28fa52ced7cf1c122a185e) **ARM: msm: Make 8660 a DT only target**
	1. Here all usages of `MACHINE_START` macro are removed and only DeviceTree code is left
9. [d0e190c](https://github.com/gfgit/msm8930-mainline/commit/d0e190c37a85f1a8b7dccada8b2fb8fa64c36635) **ARM: msm: Create a common board-dt and config ARCH_MSM_DT**
	1. **VERY INTERESTING COMMIT**
	2. This commit removes specific files, which were simplified already in previous commits, and makes only one `mach-msm` board file.
	3. New generic file: `arch/arm/mach-msm/board-dt.c`
	4. **Removed:** `arch/arm/mach-msm/board-dt-8960.c`
	5. **Removed:** `arch/arm/mach-msm/board-dt-8660.c`
9. [cc60a1a](https://github.com/gfgit/msm8930-mainline/commit/cc60a1a4d47a4dea2ca04bad6f16bf43dcd5c1d6) **ARM: dts: msm: split out msm8660 and msm8960 soc into dts include**
	1. New file: `arch/arm/boot/dts/qcom-msm8660.dtsi`
	2. New file: `arch/arm/boot/dts/qcom-msm8960.dtsi`
10. [9857a75](https://github.com/gfgit/msm8930-mainline/commit/9857a7531ffcf35442f9ef707e4e0d94a7a7fb18) **ARM: msm: Add support for APQ8074 Dragonboard**
	1. Adds support for a new board
11. [8fc1b0f](https://github.com/gfgit/msm8930-mainline/commit/8fc1b0f87d9fcc7f05873c70b3003328c3d7defa) **ARM: qcom: Split Qualcomm support into legacy and multiplatform**
	1. This commit needs more investigation.
	2. Seems to just move things in different folders
12. [80483c3](https://github.com/gfgit/msm8930-mainline/commit/80483c3abf8423e6ec4fb63647a8e2e1f5976801) **ARM: qcom: Cleanup/Remove unnecessary board file**
	1. Definitive **removal** of `arch/arm/mach-qcom/board.c`
	2. Seems not all is handled in generic way by parsing device tree
	
## Generic ARM Machine

Introduced in commit:

[883a106](https://github.com/gfgit/msm8930-mainline/commit/883a106b0866ca8d75b5520bdb3ca1cf8e3730ba) **ARM: default machine descriptor for multiplatform**

Is defined at: `arch/arm/kernel/devtree.c:193`

```
const struct machine_desc * __init setup_machine_fdt(void *dt_virt)
{
	const struct machine_desc *mdesc, *mdesc_best = NULL;

	DT_MACHINE_START(GENERIC_DT, "Generic DT based system")
		.l2c_aux_val = 0x0,
		.l2c_aux_mask = ~0x0,
	MACHINE_END

	mdesc_best = &__mach_desc_GENERIC_DT;

	if (!dt_virt || !early_init_dt_verify(dt_virt))
		return NULL;

	mdesc = of_flat_dt_match_machine(mdesc_best, arch_get_next_mach);

	if (!mdesc) {
		const char *prop;
		int size;
		unsigned long dt_root;

		early_print("\nError: unrecognized/unsupported "
			    "device tree compatible list:\n[ ");

		dt_root = of_get_flat_dt_root();
		prop = of_get_flat_dt_prop(dt_root, "compatible", &size);
		while (size > 0) {
			early_print("'%s' ", prop);
			size -= strlen(prop) + 1;
			prop += strlen(prop) + 1;
		}
		early_print("]\n\n");

		dump_machine_table(); /* does not return */
	}

	/* We really don't want to do this, but sometimes firmware provides buggy data */
	if (mdesc->dt_fixup)
		mdesc->dt_fixup();

	early_init_dt_scan_nodes();

	/* Change machine number to match the mdesc we're using */
	__machine_arch_type = mdesc->nr;

	return mdesc;
}
```


# MACH-MSM Removal

`arch/arm/mach-msm` folder gets removed in:

[c0c89fa](https://github.com/gfgit/msm8930-mainline/commit/c0c89fafa289ea241ba3fb22d6f583f8089a719e) **ARM: Remove mach-msm and associated ARM architecture code**

This commit might be useful to first port our downstream code to last `mach-msm` state prior to commit noted above, which is **Kernel v4.0-rc3** so newer than our downstream kernel **v3.4.something**.

Then we port this code to Device Tree
