# Downstream Kernel samsung-serranolte

Samsung Galaxy S4 Mini LTE based on MSM8930 SoC

## Kernel Config

KConfig path: `arch/arm/mach-msm/Kconfig`
Related Makefiles: `arch/arm/mach-msm/Makefile` and `arch/arm/mach-msm/Makefile.boot`

## Some config values

### `MACH_SERRANO_EUR_LTE`

Which depends on:
`MACH_SERRANO`

Referenced in:

#### `arch/arm/mach-msm/board-8930-input-mxt.c:811`

Specific function `static void mxts_power_onoff(int onoff)`

#### `arch/arm/mach-msm/board-8930-pmic.c`

Line 195: `/* Initial PM8917 MPP configurations */`

Line 359: `extern void tsu6721_monitor(void);`
called by `static void sec_bat_monitor_additional_check(void)`
referenced inside `struct pm8921_sec_battery_data pm8921_battery_pdata`
referenced inside `struct pm8921_charger_platform_data pm8921_chg_pdata`

### `MACH_SERRANO`

Which depends on:
`ARCH_MSM8930`

Referenced in:

#### `arch/arm/mach-msm/board-8930-input-mxt.c:610`

Specific function `static void mxts_power_onoff(int onoff)`

### `ARCH_MSM8930`

Which depends on:
```
ARCH_MSM_KRAITMP
ARM_GIC
CPU_V7
GPIO_MSM_V2
MSM_GPIOMUX
MSM_SCM if SMP
MSM_DIRECT_SCLK_ACCESS
REGULATOR
MSM_RPM_REGULATOR
MSM_RPM
MSM_XO
MSM_QDSP6_APR
MSM_QDSP6_CODECS
MSM_PIL
MSM_AUDIO_QDSP6 if SND_SOC
CPU_HAS_L2_PMU
MSM_SPM_V2
MSM_L2_SPM
MSM_NATIVE_RESTART
DONT_MAP_HOLE_AFTER_MEMBANK0
MSM_REMOTE_SPINLOCK_SFPB
ARCH_HAS_HOLES_MEMORYMODEL
MULTI_IRQ_HANDLER
MSM_PM8X60 if PM
HOLES_IN_ZONE if SPARSEMEM
ARM_HAS_SG_CHAIN
MSM_KRAIT_WFE_FIXUP
MSM_IOMMU_GPU_SYNC
MSM_CPU_PWRCTL
HAS_MACH_MEMUTILS
GENERIC_TIME_VSYSCALL
```

TODO: check which of these configs are already mainlined

## Mainline config

Found `ARM_GIC`
Found `CPU_V7`
Found `REGULATOR`
Found `SND_SOC`
Found `ARCH_HAS_HOLES_MEMORYMODEL`
Found `GENERIC_TIME_VSYSCALL`

Other configs might be under different name or splitted in different way
