# Patching PmOS/Alpine packages

## Fork Apline package

If target package is not specific to PostmarketOS, then probably it comes from Apline Linux package repository `aports`.  
Otherwise it's in `pmaports` repository.

To get a local copy of an Alpine package run:  
```
pmbootstrap aportgen --fork-alpine <package-name>
```

It will create a copy in `~/.local/var/pmbootstrap/cache_git/pmaports/temp/<package-name>`

Remember to add description on first line of new `APKBUILD` file and make a `git commit`

## Prevent strip

By default debug symbols get stripped.

In APKBUILD file add `!strip` in `options=""` line.

If package is built with CMake also set `-DCMAKE_BUILD_TYPE=Debug`

## Sideload

Handy tool to install locally built package on running device:

`pmbootstrap sideload <package name>`

It uses SSH, by default `user@172.16.42.1` and runs `apk` on device so it asks for remote admin password.