# SSH tips and tricks

## USB tethering using NetworkManager breaks ssh

USB Ethernet seems broken on S4 Mini because of NetworkManager managing `usb0` insterface.

Specifically since [pmaports@4b92e922ef8de694ba289707063e0c5d1b363903](https://gitlab.com/postmarketOS/pmaports/-/commit/4b92e922ef8de694ba289707063e0c5d1b363903) commit.

More details in related [MR 3819](https://gitlab.com/postmarketOS/pmaports/-/merge_requests/3819).

See also the [pmaports bug report](https://gitlab.com/postmarketOS/pmaports/-/issues/2483).

### Quick fix

Disable NetworkManager on phone with `sudo rc-update del NetworkManager` and reboot.

### Revert commit

To keep using NetworkManager, one can revert the commit that broke ssh in postmarketos-base-ui package.
Checkout Ignacy `pmaports` branch [fix-ssh](https://gitlab.com/ignapk/pmaports/-/tree/fix-ssh).
It contains patched postmarketos-base-ui package sources in a simple revert of the commit that added USB tethering using NetworkManager, which is the commit that broke the ssh in our lovely device.

### Proper fix?

TODO: investigate why USB tethering using NetworkManager breaks ssh.

## Copy file to Guest OS

`scp -P 2222 /path/to/file user@172.16.42.1:/remote/path`

Make sure you have write access to remote path. 

## Enable SSH TCP forwarding

Edit `/etc/ssh/sshd_config` on Guest.

Uncomment or enable line `AllowTcpForwarding yes`

This is useful to run GDB Server on Guest and control it from host.

### SSH Tunnel to guest OS

On host run `ssh -p 2222 -L local_port:127.0.0.1:guest_port user@172.16.42.1`
Example: `ssh -p 2222 -L 5001:127.0.0.1:5000 user@172.16.42.1`

## Kill GUI session from SSH

Run `kill -9 -1` from SSH. This will kill all user process and get you back to login screen. (Which in case of TinyDM auto logins to a new GUI session).
Side effect: SSH connection gets closed but you can reconnect just after.

## SSH File System

`sshfs` package let's you FUSE-mount the device filesystem inside a local folder. Preinstalled on Ubuntu.

This avoids boring `nc` back and forth.

Usage: `sshfs user@address:/remote/path /local/folder`

Example: `sshfs user@172.16.42.1:/ ./RemoteFS/`

